package com.gxwebsoft.tower.controller;

import com.gxwebsoft.common.core.web.BaseController;
import com.gxwebsoft.common.system.entity.User;
import com.gxwebsoft.tower.service.TowerCustomerService;
import com.gxwebsoft.tower.entity.TowerCustomer;
import com.gxwebsoft.tower.param.TowerCustomerParam;
import com.gxwebsoft.common.core.web.ApiResult;
import com.gxwebsoft.common.core.web.PageResult;
import com.gxwebsoft.common.core.web.PageParam;
import com.gxwebsoft.common.core.web.BatchParam;
import com.gxwebsoft.common.core.annotation.OperationLog;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.security.access.prepost.PreAuthorize;
import org.springframework.web.bind.annotation.*;

import javax.annotation.Resource;
import java.util.List;

/**
 * 客户管理控制器
 *
 * @author 科技小王子
 * @since 2023-06-08 21:04:27
 */
@Api(tags = "客户管理管理")
@RestController
@RequestMapping("/api/tower/tower-customer")
public class TowerCustomerController extends BaseController {
    @Resource
    private TowerCustomerService towerCustomerService;

    @PreAuthorize("hasAuthority('tower:towerCustomer:list')")
    @OperationLog
    @ApiOperation("分页查询客户管理")
    @GetMapping("/page")
    public ApiResult<PageResult<TowerCustomer>> page(TowerCustomerParam param) {
//        PageParam<TowerCustomer, TowerCustomerParam> page = new PageParam<>(param);
//        page.setDefaultOrder("create_time desc");
//        return success(towerCustomerService.page(page, page.getWrapper()));
        // 使用关联查询
        return success(towerCustomerService.pageRel(param));
    }

    @PreAuthorize("hasAuthority('tower:towerCustomer:list')")
    @OperationLog
    @ApiOperation("查询全部客户管理")
    @GetMapping()
    public ApiResult<List<TowerCustomer>> list(TowerCustomerParam param) {
        PageParam<TowerCustomer, TowerCustomerParam> page = new PageParam<>(param);
        page.setDefaultOrder("create_time desc");
        return success(towerCustomerService.list(page.getOrderWrapper()));
        // 使用关联查询
        //return success(towerCustomerService.listRel(param));
    }

    @PreAuthorize("hasAuthority('tower:towerCustomer:list')")
    @OperationLog
    @ApiOperation("根据id查询客户管理")
    @GetMapping("/{id}")
    public ApiResult<TowerCustomer> get(@PathVariable("id") Integer id) {
        return success(towerCustomerService.getById(id));
        // 使用关联查询
        //return success(towerCustomerService.getByIdRel(id));
    }

    @PreAuthorize("hasAuthority('tower:towerCustomer:save')")
    @OperationLog
    @ApiOperation("添加客户管理")
    @PostMapping()
    public ApiResult<?> save(@RequestBody TowerCustomer towerCustomer) {
        // 记录当前登录用户id
        User loginUser = getLoginUser();
        if (loginUser != null) {
          towerCustomer.setUserId(loginUser.getUserId());
        }
        if (towerCustomerService.save(towerCustomer)) {
            return success("添加成功");
        }
        return fail("添加失败");
    }

    @PreAuthorize("hasAuthority('tower:towerCustomer:update')")
    @OperationLog
    @ApiOperation("修改客户管理")
    @PutMapping()
    public ApiResult<?> update(@RequestBody TowerCustomer towerCustomer) {
        if (towerCustomerService.updateById(towerCustomer)) {
            return success("修改成功");
        }
        return fail("修改失败");
    }

    @PreAuthorize("hasAuthority('tower:towerCustomer:remove')")
    @OperationLog
    @ApiOperation("删除客户管理")
    @DeleteMapping("/{id}")
    public ApiResult<?> remove(@PathVariable("id") Integer id) {
        if (towerCustomerService.removeById(id)) {
            return success("删除成功");
        }
        return fail("删除失败");
    }

    @PreAuthorize("hasAuthority('tower:towerCustomer:save')")
    @OperationLog
    @ApiOperation("批量添加客户管理")
    @PostMapping("/batch")
    public ApiResult<?> saveBatch(@RequestBody List<TowerCustomer> list) {
        if (towerCustomerService.saveBatch(list)) {
            return success("添加成功");
        }
        return fail("添加失败");
    }

    @PreAuthorize("hasAuthority('tower:towerCustomer:update')")
    @OperationLog
    @ApiOperation("批量修改客户管理")
    @PutMapping("/batch")
    public ApiResult<?> removeBatch(@RequestBody BatchParam<TowerCustomer> batchParam) {
        if (batchParam.update(towerCustomerService, "customer_id")) {
            return success("修改成功");
        }
        return fail("修改失败");
    }

    @PreAuthorize("hasAuthority('tower:towerCustomer:remove')")
    @OperationLog
    @ApiOperation("批量删除客户管理")
    @DeleteMapping("/batch")
    public ApiResult<?> removeBatch(@RequestBody List<Integer> ids) {
        if (towerCustomerService.removeByIds(ids)) {
            return success("删除成功");
        }
        return fail("删除失败");
    }

}
